<?php
// Mark Lin
// Program: Super Add for Cacti



chdir('../../');
include_once("./include/auth.php");  // authentication

//include_once($config["base_path"] . "/plugins/thold/thold_functions.php");

include_once($config["base_path"]."/lib/api_automation_tools.php");
include_once($config["base_path"]."/lib/data_query.php");
include_once($config["base_path"]."/lib/utility.php");
include_once($config["base_path"]."/lib/sort.php");
include_once($config["base_path"]."/lib/template.php");
include_once($config["base_path"]."/lib/api_data_source.php");
include_once($config["base_path"]."/lib/api_graph.php");
include_once($config["base_path"]."/lib/snmp.php");
include_once($config["base_path"]."/lib/data_query.php");
include_once($config["base_path"]."/lib/api_device.php");
// Graph api
include_once($config["base_path"]."/lib/api_graph.php");

// Show top header of the site
include($config["include_path"] . "/top_header.php");


// Form actions
$action = (isset($_REQUEST['action']))?$_REQUEST['action']:""; 

// Output buffer
$o = '';

// Get a list of hosts
$hosts = getHosts();

// Get graph templates;
$graphTemplates = getGraphTemplates();

// Get host templates
$hostTemplates = getHostTemplates();

//print_r($hosts);

foreach ($hosts as $host_id => $host) {
	$t[$host_id] = $host['hostname'];
}
$hosts = $t;

// Sort the array
asort($hosts);
asort($graphTemplates);



// If there is an action save from form_button_save, then let's create all the graphs
if ( $action == 'save' ) {
	if ( isset($_REQUEST['host_ids']) && isset($_REQUEST['graph_template_ids']))  {
		
		$o = "Saving the templates...<br/>\n";
		foreach ( $_REQUEST['host_ids'] as $host_id ) {
			foreach ( $_REQUEST['graph_template_ids'] as $graph_template_id ) {
				$o .= "Adding ".$hosts[$host_id]." with ".$graphTemplates[$graph_template_id]."...<br/>\n";	
	
				// Check if the graph exist already.
				$existsAlready = db_fetch_cell("SELECT id FROM graph_local WHERE graph_template_id=$graph_template_id AND host_id=$host_id");
				$dataSourceId  = db_fetch_cell("SELECT DISTINCT
				data_template_rrd.local_data_id
				FROM graph_templates_item, data_template_rrd
				WHERE graph_templates_item.local_graph_id = " . $existsAlready . " 
				AND graph_templates_item.task_item_id = data_template_rrd.id");

				if ((isset($existsAlready)) && ($existsAlready > 0) ) {
   	   $o .= "<font color='#990000'>ERROR: Not Adding Graph - this graph already exists - graph-id: ($existsAlready) - data-source-id: ($dataSourceId)</font><br/>\n";
				}
				// Actuall adding the graph specified by the template to the host
				else{
					$empty = array();
					$returnArray = create_complete_graph_from_template($graph_template_id, $host_id, "", $empty);
					$dataSourceId = db_fetch_cell("SELECT DISTINCT
					data_template_rrd.local_data_id
					FROM graph_templates_item, data_template_rrd
					WHERE graph_templates_item.local_graph_id = " . $returnArray["local_graph_id"] . "
					AND graph_templates_item.task_item_id = data_template_rrd.id");

			    $o .= "<font color='#00aa00'>Graph Added to ".$hosts[$host_id]." - graph-id: (" . $returnArray["local_graph_id"] . ") - data-source-id: ($dataSourceId)</font><br/>\n";

					# Replace the special field in data source with proper value
					push_out_host($host_id,0);
				}   
			}
		}
	}
	else {
		$o = "Need to specify both host and template. <br/>\n";

	}
}

// Let's build some select function
$host_select = "<select name='host_ids[]' multiple size='20'>";

foreach ($hosts as $host_id => $hostname) {
	$host_select .= "<option id='$host_id' value='$host_id'>$hostname</option>\n";
}
$host_select .= "</select>\n";

$graph_template_select = "<select name='graph_template_ids[]' multiple size='20'>";
foreach ($graphTemplates as $templateId => $templateName) {
	$graph_template_select .= "<option id='$templateId' value='$templateId'>$templateName</option>\n";
}

$graph_template_select .= "</select>\n";

//print_r($graphTemplates);

echo "<form action='sadd.php' method='post'>";

html_start_box("<strong>Super Add Console <br/>*** Use with Extreme Caution ***</strong>" , "98%", $colors["header"], "3", "center", "");


// Display the header
html_header(array("Select Hosts","Select Graph Templates"));

echo '<tr>';

// Host Selection
echo '<td>';
echo $host_select;
echo '</td>';

// Graph Templates Selection
echo '<td>';
echo $graph_template_select;
echo '</td>';

echo '</tr>';

html_end_box();

form_save_button("sadd.php", "create");

echo '</form>';


if ( $o ) {
	html_start_box("<strong>Result</strong>" , "98%", $colors["header"], "3", "center", "");
	// Display output buffer
	echo "<tr bgcolor='#" . $colors["header_panel"] . "'>
		<td colspan='2'>
			$o
		</td></tr>";
	html_end_box();
}

// Show bottom footer
include_once($config["include_path"] . "/bottom_footer.php");
?>
