<?php
// Mark Lin
// Add device front gui

chdir('../../');
include_once("./include/auth.php");  // authentication

include_once($config["base_path"]."/lib/api_automation_tools.php");
include_once($config["base_path"]."/lib/utility.php");
include_once($config["base_path"]."/lib/api_data_source.php");
include_once($config["base_path"]."/lib/api_graph.php");
include_once($config["base_path"]."/lib/snmp.php");
include_once($config["base_path"]."/lib/data_query.php");
include_once($config["base_path"]."/lib/api_device.php");


// Header
include($config["include_path"] . "/top_header.php");
 

$hostTemplates = getHostTemplates();
$hostList = getHostsByDescription();
$communities = db_fetch_assoc("SELECT DISTINCT
     snmp_community
    FROM host
    ORDER BY snmp_community");

// Form actions
$action = (isset($_REQUEST['action']))?$_REQUEST['action']:""; 

// Output buffer
$o = '';

// Post actions
if ( $action == 'save' ) {

	if ( isset($_REQUEST['hostnames']) && isset($_REQUEST['host_template']) ) {


		// Modify these default values for your environment?
		$snmp_ver      = 2;
		$disable       = 0;
		$notes         = "";
    
		$snmp_username        = "";
		$snmp_password        = "";
		$snmp_auth_protocol   = "";
		$snmp_priv_passphrase = "";
		$snmp_priv_protocol   = "";
		$snmp_context         = "";
		$snmp_port            = 161;
		$snmp_timeout         = 500;
	
		$avail        = 2;
		$ping_method  = 3;
		$ping_port    = 23;
		$ping_timeout = 400;
		$ping_retries = 1;
		$max_oids     = 10;
		
		$hostnames = preg_split("/[\r\n]+/",$_REQUEST['hostnames']);
		$template_id = $_REQUEST['host_template'];
		$community     = $_REQUEST['community'];


		// Add each host with the host template
		foreach ( $hostnames as $hostname ) {
			$ip = gethostbyname(rtrim($hostname));
			if ( $ip != $hostname && $hostname != '') {
				$h[$hostname] = $ip;

				// Checking data base to see if host description already exist
				if ( isset($hostList[$hostname]) ) {
					$o .= "<font color='#990000'>$hostname already exists, not adding.</font><br/>\n";
				}
				else {
					// All check pass, let's add it, ip is the same as hostname, you can chenage the fourth parameter to $ip for ip.
					$host_id = api_device_save(0, $template_id, $hostname, $hostname,
						$community, $snmp_ver, $snmp_username, $snmp_password,
						$snmp_port, $snmp_timeout, $disable, $avail, $ping_method,
						$ping_port, $ping_timeout, $ping_retries, $notes,
						$snmp_auth_protocol, $snmp_priv_passphrase,
						$snmp_priv_protocol, $snmp_context, $max_oids);

					$o .= "Adding $hostname ($ip) as \"" . $hostTemplates[$template_id] . "\"<br/>\n";
					if (is_error_message()) {
						$o .= "ERROR: Failed to add this device\n";
					} 
					else {
						$o .= "Success - new device-id: ($host_id)<br/>\n";
					}
				}
			}
			elseif ( $hostname != '' ) {
				$o .= "<font color='#990000'>$hostname failed to look up in dns, not adding.</font><br/>\n";
			}
		}
	}
	else {
		$o .= "Need to specify both host and template. <br/>\n";
	}
}



$host_template_select = '<select name="host_template" size="10">';

foreach ( $hostTemplates as $template_id => $template_name ) {
	$host_template_select .= "<option value='$template_id'>$template_name</option>";
}

$host_template_select .= '</select>';

$textarea['method'] = 'textarea';
$textarea['textarea_rows'] = 10;
$textarea['textarea_cols'] = 40;
$textarea['value'] = "";

$community_select = '<select name="community">';
foreach ($communities as $community) {
	if ( $community['snmp_community'] != '' ) {
		$community_select .= "<option value='".$community["snmp_community"]."'>". $community["snmp_community"]."</option>\n";
	}
}
$community_select .= '</select>';

// Get the form going
echo "<form action='sadd_devices.php' method='post'>";
html_start_box("<strong>Super Add Console <br/>*** Use with Extreme Caution ***</strong>" , "98%", $colors["header"], "2", "center", "");

// Header
html_header(array("Enter hostnames (one per line)","Select Host Template","Select SNMP Community"));
echo '<tr><td>';
draw_edit_control('hostnames',$textarea);
echo '</td>';

echo '<td>';
echo $host_template_select;
echo '</td>';

echo '<td>';
echo $community_select;
echo '</td></tr>';

html_end_box();

form_save_button("sadd_devices.php", "create");

echo '</form>';


if ( $o ) {
	html_start_box("<strong>Result</strong>" , "98%", $colors["header"], "3", "center", "");  // Display output buffer
	echo "<tr bgcolor='#" . $colors["header_panel"] . "'>
		<td colspan='2'>
			$o
		</td></tr>";
	html_end_box();
}

// Footer
include($config["include_path"] . "/bottom_footer.php");

?>
